var xdoc;
var xwin;
var viewMode;
function toggleMode(e)
{

	if(!e) e=window.event;
	var outer=target(e);
	while(!outer.eframe) outer=outer.parentNode;
	xwin=outer.eframe.contentWindow;

	xdoc=xwin.document;
	
 // change the display styles
  if(viewMode == 2){
    xdoc.body.style.fontFamily = '';
    xdoc.body.style.fontSize = '';
    xdoc.body.style.color = '';
    xdoc.body.style.fontWeight = '';
    xdoc.body.style.backgroundColor = '';
  }else{
    xdoc.body.style.fontFamily = 'monospace';
    xdoc.body.style.fontSize = '10pt';
    xdoc.body.style.color = '#000';
    xdoc.body.style.backgroundColor = '#fff';
    xdoc.body.style.fontWeight = 'normal';
  }

 // do the content swapping
  if(isMSIE()){
    _toggle_mode_ie(outer);
  }else{
    _toggle_mode_gecko(outer);
  }
}

/**
* WYSIWYG_Editor::_toggle_mode_ie
*
* Toggles between design view and source view in the IFRAME element for MSIE
**/
function _toggle_mode_ie(outer){
  if(viewMode == 2){
    xdoc.body.innerHTML = xdoc.body.innerText;
    xwin.focus();
    viewMode = 1; // WYSIWYG
	outer.field_switch.value="edit markup";
  }else{
    xdoc.body.innerText = xdoc.body.innerHTML;
    xwin.focus();
    viewMode = 2; // Code
	outer.field_switch.value="edit html";
  }
}

/**
* WYSIWYG_Editor::_toggle_mode_gecko
*
* Toggles between design view and source view in the IFRAME element for Gecko browsers
**/
function _toggle_mode_gecko(o)
{
  if(viewMode == 2){
    var html = xdoc.body.ownerDocument.createRange();
    html.selectNodeContents(xdoc.body);
    xdoc.body.innerHTML = html.toString();
    xwin.focus();
    viewMode = 1; // WYSIWYG
	outer.field_switch.value="edit html";
}else{
    var html = document.createTextNode(xdoc.body.innerHTML);
    xdoc.body.innerHTML = '';
    xdoc.body.appendChild(html);
    xwin.focus();
    viewMode = 2; // Code
	outer.field_switch.value="edit markup";
  }
}


function isMSIE()
{
  if(typeof(document.all)=='object'){
    return true;
  }else{
    return false;
  }
}

function init_editor(id)
{
//	eid = document.getElementById(id);
	eid = document.getElementById(id);	
	ew = eid.contentWindow;
	ew.document.designMode = "On";
	return ew;
}

function ed_mousedown(e)
{
	t=target(e);
	if(t.getAttribute('menu')=='true'){
		var outer=t;
		while(!outer.eframe) outer=outer.parentNode;
		var m=ed_show_menu(t.className);
		m.eframe=outer.eframe;
		do_menu_show('ed_menu_'+t.className,e,true);
		dge('ed_menu_'+t.className)._hide_sel=t;
	}
  	return stopEvent(e);
}

function ed_show_menu(id){
	var o=dge('ed_menu_'+id);
	if (!o){
		var o=document.createElement("div");
		o.className = 'xmenu';
		o.id = 'ed_menu_'+id;
		if (id=='fontname'){
			o.innerHTML='<a href="#" class="fontname" param="arial,san-serif">Arial</a>'+
						'<a href="#" class="fontname" param="comic sans ms,san-serif">Comic Sans MS</a>'+
						'<a href="#" class="fontname" param="courier new,monospace">Courier New</a>'+
						'<a href="#" class="fontname" param="garamond,serif">Garamond</a>'+
						'<a href="#" class="fontname" param="helvetica,san-serif">Helvetica</a>'+
						'<a href="#" class="fontname" param="tahoma,san-serif">Tahoma</a>'+
						'<a href="#" class="fontname" param="times new roman,serif">Times New Roman</a>'+
						'<a href="#" class="fontname" param="verdana,san-serif">Verdana</a>';

		}else if (id=='fontsize'){
			o.innerHTML='<a href="#" class="fontsize" param="1" >8 pt</a>'+
						'<a href="#" class="fontsize" param="2">10 pt</a>'+
						'<a href="#" class="fontsize" param="3">12 pt</a>'+
						'<a href="#" class="fontsize" param="4">14 pt</a>'+
						'<a href="#" class="fontsize" param="5">16 pt</a>'+
						'<a href="#" class="fontsize" param="6">24 pt</a>'+
						'<a href="#" class="fontsize" param="7">30 pt</a>';
		}else{
			o.innerHTML="boohoo..."
		}
		o.onmouseup=ed_click;
		o.onmouseout=function(e){if(!e) e=window.event; menu_action_mouseout(e,o.id)}; 
		o.onmouseover=function(e){if(!e) e=window.event; menu_action_mouseover(event,o.id)};

		document.body.appendChild(o);
	}
	return o;
}


// *** Actually execute command in the html editor ***
function editor_do(cmd,param)
{
	xwin=(sw.active ? sw.active.field_eframe.contentWindow : document.getElementById('eframe1').contentWindow);
  	xwin.document.execCommand(cmd,false, param);
  	xwin.focus();
  	return false;
}

// Editor toolbar click handling events which never get outside these DOM elements
// generic handler for all single action html editor items
function ed_click(e,param)
{
	if(!e) e=window.event;
	var t=target(e);
	var outer=t;
	while(!outer.eframe) outer=outer.parentNode;
	xwin=outer.eframe.contentWindow;
	xwin.focus();
	if (t.tagName.toLowerCase()=="a" && t.getAttribute('menu')!='true'){
		xwin.document.execCommand(t.className,false, t.getAttribute('param'));
		if (t.parentNode._hide_sel) class_remove(t.parentNode._hide_sel,'hoverjs');
	}
  	stopEvent(e);
}
// Anything that needs more specialised action for some reason
function ed_click_ex(e,cmd,param)
{
	xwin=(sw.active ? sw.active.field_eframe.contentWindow : document.getElementById('eframe1').contentWindow);
  	xwin.focus();
  	xwin.document.execCommand(cmd,false, param);
  	return stopEvent(e);
}

function ed_content(id)
{
	var el=dge(id);
	if (!el) return '';
	
	return el.contentWindow.document.body.innerHTML;
}
function ed_init(value,etbar,eframe)
{
	if(!etbar) etbar='etbar';
	if(!eframe) eframe='eframe';
	
	var tb=dge(etbar);
	tb.eframe=dge(eframe);
	tb.field_switch=dge('editor_switch_button');
	setTimeout(function(){
		var xwin = init_editor(eframe);
		var xdoc=xwin.document;
		xdoc.open();
//		xdoc.write('<html><head>');
//		xdoc.write('<style>');
//		xdoc.write(' P{margin:0px;padding:0px;}');
//		xdoc.write(' {FONT-SIZE: 11pt;FONT-FAMILY:Arial,Helvetica,sans-serif;background:white;}');
//		xdoc.write('</style>');
//		xdoc.write('<body>'+value+'</body></html>')

		xdoc.write(value);
		xdoc.close();

	},5);
}