# this is ~flds.js

||ifdef||script_block||	
<script id="||script_block||">
||endif||


||define||ftree||true||
set_folders('<ul class="ftree">'
||begin_list_folders|| 
# Supply nested list tags around each folder (for collapsability)
  ||ifdef||level_down|| ||define||foreach||level_down|| ||begin_list_foreach||+'<ul>'||end_list_foreach||	
  ||else||||ifdef||level_up|| ||define||foreach||level_up|| ||begin_list_foreach||+'</ul></li>'||end_list_foreach||	
  ||else|| 	+'</li>'
  ||endif||||endif||

#	Some preparatory formatting
  ||define||info1||<div class="info1">1 S</div>||
  ||if(or(equal(ftree_node,(open)),equal(ftree_node,(closed))))|| ||define||evt||onclick="return fld_expand(event)"|| ||else|| ||undef||evt|| ||endif||
  ||define||icons_etc||(<div class="folder_icons"><div class="tog" ||evt||></div><div class="folder_icon"></div></div>||info1||)||

  ||if(greater_than(nfld_unread,0))|| ||define||unread_x||( (||nfld_unread||) )|| ||else|| ||define||unread_x|||| ||endif||  ||define||unread||( <b id="unread_||nfld_id||"> ||unread_x||</b> )||
# Actually output folder information
  ||if(equal(level,(0)))||
#	Customise icons if required
  	||define||icons_etc||(<div class="folder_icons folder_icons_top"><div class="tog" ||evt||></div><div class="folder_icon"></div></div>||info1||)||

# 	Deal with display of special folders	
	||undef||extra||
	||if(and(equal(nfld_id,(More Folders)),istrue(folder_fake)))|| 
#	  ||define||icons_etc||(<div class="folder_icons folder_icons_top"><div class="tog" ||evt||></div></div>||info1||)||
#	  +'<div class="fld_text_spacer"></div>'
	  +'<li class="myfld fake ||if(equal(pref_fldopen,(open)))||open||else||closed||endif||"><div class="full_cursor" style="padding-left:||mul(level,16)||px;">||icons_etc||<div class="folder top_lev_folder"><i>||web_encode_js(nfld_short_name)||</i> ||extra||'
	  +'<a href="#" class="flist_link" onclick="manage_folders(event)">Manage</a>'
	||else||
	  +'<li class="||ftree_node||" fldid="||web_encode_js(nfld_id)||" fld_type="||fld_type||"><div class="full_cursor" style="padding-left:||mul(level,16)||px;">||icons_etc||<div class="part_cursor folder top_lev_folder">||web_encode_js(nfld_short_name)|| ||web_encode_js(unread)||'
	||endif||

# 	Add extra links
	||if(equal(fld_type,1))||
	  +'<a href="#" class="flist_link" onclick="refresh(event)">Refresh</a>'
# 			  Trash folder
	||else|| ||if(or(equal(fld_type,4),equal(fld_type,6)))|| 
	  +'<a href="#" class="flist_link" onclick="do_purge(event)">Purge</a>'
	||endif|| ||endif||

	  +'</div></div>'
	
  ||else||
# 	Deal with display of normal folders	
	+'<li class="||ftree_node||" fldid="||web_encode_js(nfld_id)||" fld_type="||fld_type||"><div class="full_cursor" style="padding-left:||mul(level,16)||px;">||icons_etc||<div class="part_cursor folder">||web_encode_js(nfld_short_name)|| ||web_encode_js(unread)||</div></div>'
  ||endif||
||end_list_folders|| 
# Apply end of list formatting
||ifdef||level_up|| ||define||foreach||level_up|| ||begin_list_foreach||+'</ul>'||end_list_foreach|| ||endif|| + '</ul>');


||ifdef||script_block||	
</script>
||endif||	